#ifndef REACTORFORTRAN_HH
#define REACTORFORTRAN_HH
//
//  Fortran prototypes for calling from C++
//
extern "C" {
  //
  // Hbook Interfaces
  //
  void hbook_init__();

  void hropen_(const int&,const char*,const char*,const char*,int&,int&,
	       int lchar1,int lchar2,int lchar3);
  void hbookn_(const int&,const char*,const int&,const char*,const int&,
	       const char*ntTags,
	       int lchar1,int lchar2,int lchar3,int lchar4);
  void hbook1_(const int&,const char*,const int&,
	       const float&,const float&,const float&,
	       const int title_length);
  void hfill_(const int&,const float&,const float& y=0,const float& w=1);

  void hfn_(const int&,const float*);

  void hldir_(const char*,const char*,
	      int lchar1,int lchar2);
  void hcdir_(const char*,const char*,
	      int lchar1,int lchar2);
  void hrout_(const int&,int&,const char*,
	      int lchar1);
  void hrend_(const char*,int lchar1);
  //
  //  random generators
  //
  void ranlux_(float*,const int&);
  void rluxgo_(int& lux,int& init,int& k1,int& k2);
  void rnpssn_(const float& Mean,int& Value,int& ErrorCode);
  void rnormx_(float*,int&,void(float*,const int&));
  //
  // cernlib interpolation routine
  //
  float divdif_(float*,float*,const int&,const float&,const int&);


}
#endif

 


