#include "ReactorFortran.hh"
#include "ReactorEvent.hh"
#include "ReactorDetector.hh"
#include "ReactorXC.hh"
#include <iostream.h>
#include <math.h>
#include <string.h>

int main(){
  //
  int nevents = 10000;
  char* fileName="th13.ntuple";
  char* ntName="event data";
  //
  // init random number seed
  //
  int luxury = 2;
  int seed = 8796896;
  int k1=0;
  int k2=0;
  rluxgo_(luxury,seed,k1,k2);
  //
  // paw
  //
  hbook_init__();
  //
  int iostat;
  int ntId=1;
  int ntLun=99;
  int ntBuf=1024;
  char* dirName = "TEST    ";
  char* chopt = "N";
  hropen_(ntLun,dirName,fileName,chopt,ntBuf,iostat,
	  strlen(dirName),strlen(fileName),strlen(chopt));
  //
  // define ntuple tags here
  //
  int wordsize = 8;
  int ntVars = 19;
  float tuple[ntVars];
  char ntTags[ntVars*wordsize];
  strcpy(ntTags+ 0*wordsize,"wtc      ");
  strcpy(ntTags+ 1*wordsize,"wtf      ");
  strcpy(ntTags+ 2*wordsize,"enu      ");
  strcpy(ntTags+ 3*wordsize,"KEpos    ");
  strcpy(ntTags+ 4*wordsize,"poscos   ");
  strcpy(ntTags+ 5*wordsize,"KEneu    ");
  strcpy(ntTags+ 6*wordsize,"neucos   ");
  strcpy(ntTags+ 7*wordsize,"vposr    ");
  strcpy(ntTags+ 8*wordsize,"vposcos  ");
  strcpy(ntTags+ 9*wordsize,"vposph   ");
  strcpy(ntTags+10*wordsize,"phpos    ");
  strcpy(ntTags+11*wordsize,"phneu    ");
  strcpy(ntTags+12*wordsize,"vneur    ");
  strcpy(ntTags+13*wordsize,"vneucos  ");
  strcpy(ntTags+14*wordsize,"vneuphi  ");
  strcpy(ntTags+15*wordsize,"tneu     ");
  strcpy(ntTags+16*wordsize,"npe      ");
  strcpy(ntTags+17*wordsize,"atten    ");
  strcpy(ntTags+18*wordsize,"sfact    ");

  //
  // set up paw ntuple
  //  
  hbookn_(ntId,ntName,ntVars,dirName,1000,ntTags,
	  strlen(ntName),strlen(dirName),wordsize,ntVars);
  //
  // last argument is need for c++ ==> f strings
  //
  hbook1_(101,"phpos",200,0,0.02,0,strlen("phpos"));
  hbook1_(102,"phneu",200,0,0.02,0,strlen("phneu"));
  //
  hbook1_(201,"tpos",200,0,50,0,strlen("tpos"));
  hbook1_(202,"tneu",200,0,50,0,strlen("tneu"));
  //
  // set up simple detector model
  //
  ReactorDetector Detector;
  //
  // event loop
  //
  for (int events = 0;events<nevents;events++){

    ReactorEvent Event;

    double light = Detector.LightsOut(Event);

    tuple[ 0] = Event.GetXCWeight();
    tuple[ 1] = Event.GetFluxWeight();
    tuple[ 2] = Event.GetEnu();
    tuple[ 3] = Event.GetPositronKE();
    tuple[ 4] = Event.GetCosThetaLab();
    tuple[ 5] = Event.GetNeutronKE();
    tuple[ 6] = Event.GetNeutronCosTheta();
    tuple[ 7] = Event.GetVertexR();
    tuple[ 8] = Event.GetVertexCosTheta();
    tuple[ 9] = Event.GetVertexPhi();
    tuple[10] = Detector.GetPHpositron();
    tuple[11] = Detector.GetPHneutron();
    tuple[12] = Event.GetnVertexR();
    tuple[13] = Event.GetnVertexCosTheta();
    tuple[14] = Event.GetnVertexPhi();
    tuple[15] = Event.GetNeutronTime();
    tuple[16] = Detector.GetMeanNpe();
    tuple[17] = Detector.GetMeanAtten();
    tuple[18] = Detector.GetMeanSfactor();

    hfn_(ntId,tuple);

    int npmt=Detector.GetNpmt();
    for(int n=0;n<npmt;n++){
      double xyzpmt[3];
      double phpos,phneu;
      double tpos,tneu;
      
      Detector.GetPMTdata(n,xyzpmt,phpos,phneu,tpos,tneu);

      hfill_(101,phpos);
      hfill_(102,phneu);

      hfill_(201,tpos);
      hfill_(202,tneu);
    }
  }
  //
  // close up paw
  //
  hldir_(" "," ",strlen(" "),strlen(" "));
  char* dirName2 = "//TEST";
  hcdir_(dirName2," ",strlen(dirName2),strlen(" "));
  int outopt = 0;
  int icycle;
  hrout_(outopt,icycle," ",strlen(" "));
  hrend_(dirName,strlen(dirName));

	 //  hbook_end__();
}
